from util import pos_int_gauss

class GamePolicy(object):

  def __init__(self):
    self.level_commission_cost_multiplier = 300
    self.level_price_multiplier = 50
    self.relic_value_level_multiplier = 1000
    self.level_treasure_multiplier = 35 
    self.level_inn_multiplier = 25 
    self.level_resurrect_multiplier = 40
    self.hp_per_level = 5
    self.mana_per_level = 3
    self.max_party_members = 5
    self.max_party_sp = 50
    self.party_inventory_limit = 50
    self.creature_types_per_level = 6
    self.level_boss_bonus = 3
    self.creature_hold_slots = 4
    # at least five floors deep
    self.deepest_level = max(pos_int_gauss(15, 3), 5)
    self.starting_cash = self.level_commission_cost_multiplier * 25
    # half off purchases when highest charisma = 50
    self.charisma_discount_factor = 0.5
    self.exp_for_level = [
      0,        # 0
      0,        # 1
      40,       # 2
      80,       # 3
      160,      # 4
      320,      # 5
      640,      # 6
      1280,     # 7
      2560,     # 8
      5120,     # 9
      10000,    # 10
      20000,    # 11
      40000,    # 12
      80000,    # 13
      150000,   # 14
      250000,   # 15
      300000,   # 16
      350000,   # 17
      400000,   # 18
      450000,   # 19
      500000,   # 20
      550000,   # 21
      600000,   # 22
      650000,   # 23
      700000,   # 24
      750000,   # 25
      800000,   # 26
      850000,   # 27
      900000,   # 28
      950000,   # 29
      1000000,  # 30
      1100000,  # 31
      1200000,  # 32
      1300000,  # 33
      1400000,  # 34
      1500000,  # 35
      1600000,  # 36
      1700000,  # 37
      1800000,  # 38
      1900000,  # 39
      2000000,  # 40
      2200000,  # 41
      2400000,  # 42
      2600000,  # 43
      2800000,  # 44
      3000000,  # 45
      3200000,  # 46
      3400000,  # 47
      3600000,  # 48
      3800000,  # 49
      4000000]  # 50

