from random import randint

def roll(str):
  """ pass this function a dice spec in the form xdy, where x is the
number of dice to roll and y is the number of sides for each die. Passing
an integer is the same as passing 'dx' where x is the integer passed."""

  if type(str) == int:
    return randint(1, str)

  (num, sides) = str.split('d')
  if not num:
    return randint(1, int(sides))
  else:
    total = 0
    for i in range(0, int(num)):
      total = total + randint(1, int(sides))
    return total

class Roller(object):

  def __init__(self, rollstr):
    self.rollstr = rollstr

  def __call__(self):
    return roll(self.rollstr)

  def __str__(self):
    return self.rollstr

if __name__ == '__main__':

  print "rolling d9"
  for i in range(0,10):
    print roll('d9')

  print "rolling 2d6"
  for i in range(0,10):
    print roll('2d6')

  print "rolling 4d20"
  for i in range(0,10):
    print roll('4d20')

  print "creating roller object with 2d6"
  roller = Roller('2d6')
  for i in range(0,10):
    print roller()

