from target_type import *
from effect import *
from random import *
from damage import gen_damage
from roll import roll

class Skill(object):

  def __init__(self):
    self.name = 'random skill'
    self.restrictions = dict()
    self.bonus_from_stat = None
    self.restrict_to_level = 1
    self.mana_cost = 1
    self.sp_cost = 1

    self.effect = None 
    self.damage = None
    self.target_type = TargetAny
    self.affinity = None

  def __str__(self):
    ret = "%s Mana: %d SP: %d\n" % (self.name, self.mana_cost, self.sp_cost)
    ret += "Lev: %d Restrictions: %s\n" % (self.restrict_to_level, 
      self.restrictions)
    ret += "Targets: %s Affinity: %s\n" % (self.target_type, self.affinity)
    ret += "Effect: %s\n" % self.effect
    ret += "Damage: %s\n" % self.damage
    ret += "Effectiveness dictated by: %s" % self.bonus_from_stat
    return ret

def gen_skill(level=1):

  from game import game
  skill = Skill()
  
  skill.name = choice(['crusher', 'mud puppet', 'cranberry jam'])
  skill.affinity = choice(game.element_matrix.elements)
  skill.target_type = choice(target_list)

  random_stat = choice(stat_list)
  skill.restrictions[random_stat] = pos_int_gauss(7 + level, level)
  skill.restrict_to_level = level

  random_stat = choice(stat_list)
  skill.bonus_from_stat = random_stat

  effect = gen_debuff_effect(level)
  skill.effect = effect

  skill.mana_cost = pos_int_gauss(level, level/2)

  # big damage uses SP
  if roll('d6') == 1:
    skill.sp_cost = abs(level*2 + int(gauss(0, level)))
    skill.damage = gen_damage(level*2)
  else:
    skill.damage = gen_damage(level)

  return skill

if __name__ == '__main__':

  game.init_test_game()
  from game import game

  for i in range(1, 50, 3):
    skill = gen_skill(i)
    print skill

